const reconnect = function (options) {
  console.log("connecting")
  options.webSocket = new WebSocket("ws://192.168.4.1:8080");
  options.webSocket.onopen = function (event) {
    options.isConnected = true;
    console.log(`[open] ws: Connection established: ${event.code}`);
  };
  options.webSocket.onmessage = function (event) {
    console.log(`[message] ws: Data received from server: ${event.data}`);
  };
  options.webSocket.onclose = function (event) {
    if (event.wasClean) {
      console.log(
        `[close] ws: Connection closed cleanly, code=${event.code} reason=${event.reason}`
      );
    } else {
      console.log("[close] ws: Connection died");
    }
    options.isConnected = false;
  };
  options.webSocket.onerror = function (error) {
    console.log(`[error] ws: ${error.message}`);
  };
}

// const isConnected = function () {
//   if (this.webSocket != null) {
//     console.log(this.webSocket.readyState)
//     return this.webSocket.readyState == WebSocket.OPEN
//   }
//   return false
// }

import { ref } from "vue"

// plugins/i18n.js
export default {
  install: (app, options) => {
    let webSocket = null;
    app.config.globalProperties.webSocket = webSocket
    app.config.globalProperties.reconnect = () => reconnect(options)

    app.provide('ws', options)
    app.provide('isConnected', ref(options.isConnected))
  }
}
